*! version 1.0.5  26jul2004
program define _get_diparmopts, sclass
	if _caller() < 8.2 {
		_get_diparmopts_8 `0'
		exit
	}
	version 8.2
	local version : di "version " string(_caller()) ":"

	syntax [, diparmopts(string asis)	///
		EXECute soptions bottom plus	///
		SYNTAXonly			///
		*				///
	]
	// `goptions' has global options to splice into the -diparm()- options
	local goptions `options'

	// check syntax of global options
	SpliceGlobals junk , `goptions'

	local 0 `", `diparmopts'"'
	local diparmopts
	local k 0
	syntax [, diparm(string asis) * ]
	while `"`diparm'"' != "" {
		local ++k
		local single 1
		local after		// empty out `after'
		capture _on_colon_parse `diparm'
		if !c(rc) {
			local single 0
			local diparm `"`s(before)'"'
			local after `"`s(after)'"'
		}
		SpliceGlobals diparm , diparm(`diparm')	///
			`syntaxonly' `goptions'		///
			// blank
		local diparm`k' `"`diparm'"'
		local diparmopts `"`diparmopts' : `diparm'"'
		if `single' | `"`:list retok after'"' == "" {
			local 0 `", `options'"'
			syntax [, diparm(string asis) * ]
		}
		else {
			local diparm `"`after'"'
		}
	}

	// check if other options should be present
	if `"`soptions'"' == "" {
		syntax [, diparm(string asis) ]
	}

	if ("`execute'" == "") {
		sreturn clear
		sreturn local options `"`options'"'
		sreturn local diparm `"`diparmopts'"'	
		capture _on_colon_parse `diparmopts'
		local k 0
		while !c(rc) & `"`s(before)'"' != "" {
			local ++k
			sreturn local diparm`k' `"`s(before)'"'
			capture _on_colon_parse `s(after)'
		}
		sreturn local k `k'
		exit
	}

	forval i = 1/`k' {
		`version' _diparm `diparm`i''
	}
	if (`"`bottom'"' != "")	_diparm __bot__
	if (`"`plus'"' != "")	_diparm __sep__
end

program SpliceGlobals
	syntax name(id="macro name" name=c_diparm) [,	///
		diparm(string asis)			///
		Level(integer `c(level)')		///
		svy Prob ci deff deft meff meft		///
		dof(passthru)				///
		syntaxonly				///
	]
	if `"`dof'"' == "" & `"`e(df_r)'"' != "" {
		capture confirm integer number `e(df_r)'
		if !c(rc) {
			local gdof dof(`e(df_r)')
		}
	}
	else	local gdof `"`dof'"'
	local glevel `level'
	local lopt level(`glevel')
	if "`svy'" != "" {
		local gsvy svy
		if "`deff'`deft'`meff'`meft'" != "" {
			if "`prob'" == "" {
				local gnoprob noprob
			}
			if "`ci'" == "" {
				local gnoci noci
			}
		}
		else {
			if "`prob'" == "" {
				if "`ci'" != "" {
					local gnoprob noprob
				}
			}
			else if "`ci'" == "" {
				local gnoci noci
			}
		}
	}
	else {
		// generate error for options that require the -svy- option
		local 0, `prob' `ci' `deff' `deft' `meff' `meft'
		syntax [, hiddenopt ]
	}

	if (`"`diparm'"' == "") exit

	local 0 `diparm'
	syntax namelist(id="eqname(s)") ///
		[, Level(passthru) NOProb Prob NOCI svy dof(passthru) * ]

	if ("`namelist'" == "__sep__") exit

	if "`noci'" == "" {
		local noci `gnoci'
	}
	if "`noprob'`prob'" == "" {
		local noprob `gnoprob'
	}
	if "`svy'" == "" {
		local svy `gsvy'
	}
	if "`level'" == "" {
		local lopt level(`glevel')
	}
	else	local lopt `level'
	if `"`dof'"' == "" {
		local dof `"`gdof'"'
	}
	if "`syntaxonly'" == "" {
		c_local `c_diparm' `namelist',	///
			`options' `svy' `noci' `noprob' `prob' `lopt' `dof'
	}
	else {
		c_local `c_diparm' `diparm'
	}
end

exit
