*! version 3.2.8  16sep2004
program define bprobit, eclass by(recall)
	version 6, missing
	local options "Level(integer $S_level)"
	if replay() {
		if "`e(cmd)'"!="bprobit" { error 301 }
		if _by() { error 190 }
		syntax [, `options']
		probit, level(`level')
		exit
	}
	syntax varlist(min=2) [if] [in] [, CLuster(varname) /*
		*/ OFFset(varname) `options' LOg SCore(string) *]
	marksample touse 

	qui count if `touse'
	if r(N)==0 { error 2000 }

 	tokenize `varlist'
        cap assert `1' == int(`1') if `touse'
        if _rc {
                di as err "`1' is not integer valued"
                exit 459 
        }
        cap assert `2' == int(`2') if `touse'
        if _rc {
                di as err "`2' is not integer valued"
                exit 459
        }

	if `level'<10 | `level'>99 { local level 95 } 
	if "`log'"=="" { local log "nolog" } 

	if "`offset'" ~= "" { local offopt "offset(`offset')" }
	if "`cluster'"~= "" { local clopt "cluster(`cluster')" }
 
 	if `"`score'"'~= "" {
 		di as err "score() not allowed with bprobit"
 		exit 198
 	}

	preserve
	quietly {
		keep if `touse'
		keep `varlist' `cluster' `offset'
		confirm new var _outcome
		tokenize `varlist'
		local lhs "`1' `2'"

		local k = _N
		local k1 = _N + 1

		tempvar pop
		quietly expand =2, clear
		gen byte _outcome=0 in 1/`k'
		replace _outcome=1 in `k1'/l
		gen `pop'=`2'-`1' in 1/`k'
		replace `pop'=`1' in `k1'/l
		mac shift 2
	}
	probit _outcome `*' [freq=`pop'], level(`level') `options' `log' /*
		*/ `clopt' `offopt'

	/* the e() stuff is inherited from -probit- except e(cmd) */
	/* double save in S_E_<stuff> and e() */
	est local cmd
	est local wexp
	est local wtype
	est local depvar "`lhs'"
	est local predict "gprobi_p"

	global S_E_nobs=e(N)
	global S_E_ll=e(ll)
	global S_E_mdf=e(df_m)
	global S_E_cmd "bprobit"
	restore
	est repost, esample(`touse')
	est local cmd "bprobit"
end
