*! version 4.0.7  29sep2004
program define spearman, rclass byable(recall)
	version 6, missing
	syntax varlist(min=2 max=2) [if] [in] 
	marksample touse
	tokenize `varlist'
	tempname N pval rho
	tempvar r1 r2
	quietly { 
		egen `r1' = rank(`1') if `touse'
		egen `r2' = rank(`2') if `touse'
		corr `r1' `r2'
		scalar `N' = r(N)
		scalar `rho' = r(rho)
		if (`rho' == 1) { scalar `pval' = 0 }
		else scalar `pval' = tprob(`N'-2, `rho'*sqrt((`N'-2)/(1-`rho'^2)))
	}
/* Print results */
	#delimit ;
       	di _n
		in gr " Number of obs = " in ye  %7.0f `N' _n
        	in gr "Spearman's rho = " in ye %12.4f `rho' _n(2)
		in gr "Test of Ho: " abbrev("`1'",20) " and " 
		      abbrev("`2'",20) " are independent" _n
       		in gr "    Prob > |t| = " in ye %12.4f `pval' ;
	#delimit cr

	ret scalar N   = `N'
	ret scalar rho = `rho'
	ret scalar p   = `pval'

	/* Double saves */
	global S_1 = `return(N)'
	global S_4 = `return(rho)'
	global S_6 = `return(p)'
end
