*! version 1.2.8  29sep2004
program define spikeplot, sort
	version 6.0, missing
	if _caller() < 8 {
		spikeplot_7 `0'
		exit
	}

	syntax varname [if] [in] [fw aw iw] [,	///
		Round(real 0)			///
		FRAC				///
		ROOT				///
		base(real 0)			///
		*				///
	]

	_get_gropts , graphopts(`options') grbyable getallowed(plot)
	local by `s(varlist)'
	local byopts `"`s(byopts)'"'
	local options `"`s(graphopts)'"'
	local plot `"`s(plot)'"'

	if "`root'" == "root" & "`frac'" == "frac" {
		di in red "must choose only one of root and frac options"
		exit 198
	}

quietly {

	tempvar data wt freq nby

	marksample touse

	gen double `data' = round(`varlist',`round') if `touse'
	local dfmt : format `varlist'
	format `data' `dfmt'

	sort `touse' `data' `by'

	local exp = cond("`exp'"=="","= 1","`exp'")
	gen double `wt' `exp'
	by `touse' `data' `by' : gen double `freq'=sum(`wt')
	by `touse' `data' `by' : replace `freq' = `freq'[_N] if `touse'

	if "`frac'" != "" {
		sort `touse' `by'
		by `touse' `by' : gen double `nby'=sum(`wt')
		by `touse' `by' : replace `nby' = `nby'[_N] if `touse'
		
		replace `freq' = `freq' / `nby'
	}
	else if "`root'" != "" { 
		replace `freq' = sqrt(`freq') 
	}
	sum `freq', meanonly
	local ymin = cond(`base' < r(min), `base', .)
	local ymax = cond(`base' > r(max), `base', .)
	if !missing(`ymin') | !missing(`ymax') {
		local yrange yscale(range(`ymin' `ymax'))
	}
	sort `by' `data' `touse'
	by `by' `data' : replace `touse' = (_n==1) if `touse'

} // quietly

	if "`frac'" != "" {
		local yttl "Fraction"
	}
	else if "`root'" != "" {
		local yttl "Root of frequency"
	}
	else	local yttl "Frequency"
	label var `freq' `"`yttl'"'

	local xttl : variable label `varlist'
	if "`xttl'" == "" {
		local xttl "`varlist'"
	}
	label var `data' `"`xttl'"'

	if "`by'" != "" {
		local byopt `"by(`by', `byopts')"'
	}

	version 8: graph twoway			///
	(spike `freq' `data'			///
		if `touse',			///
		`yrange'			///
		base(`base')			///
		ytitle(`"`yttl'"')		///
		xtitle(`"`xttl'"')		///
		`axis'				///
		`byopt'				///
		`options'			///
	)					///
	|| `plot'				///
	// blank
end

